Module Core

    Public VerboseLogging As Boolean = False
    Public Minutes As Integer = 10
    Public Threshold As Integer = 10
    Public IPTableBanningEnabled As Boolean = False
    Public BadRouteBanningEnabled As Boolean = False

    Public dl As New DataLayer.DBClass
    Private Fw1 As New Firewall

    Private Sub AttackDetected(ByVal IPString As String, ByVal Plugin As Integer, ByVal AttackTime As Date)
        Try
            If Trim(IPString) = "" Then Exit Sub 'THERE IS NOTHING TO DO
            Dim num As Integer = 0
            If VerboseLogging = True Then
                TextFileLogging("AttackDetected " & IPString)
            End If
            dl.InsertAttack(IPString, Plugin, AttackTime)
            num = dl.CheckIP(IPString, minutes)
            If VerboseLogging = True Then
                TextFileLogging("Totale Attack from IP " & IPString & " during last " & minutes & " are " & num)
            End If
            If num > threshold Then
                Fw1.BanIP(IPString)
                dl.BlackListIP(IPString, Now, "")
            End If
        Catch ex As Exception
            TextFileLogging(ex.ToString)
        End Try

    End Sub

    Sub WaitForEvent()
        Dim objWMIService
        Dim colMonitoredEvents
        Dim objLatestEvent
        Dim evento
        Dim ID As Integer
        Dim Source As String
        Dim Message As String
        Try
            Fw1.VerboseLogging = VerboseLogging
            Fw1.BadRoute = BadRouteBanningEnabled
            Fw1.IPTable = IPTableBanningEnabled

            If VerboseLogging = True Then
                TextFileLogging("Wait for events...")
            End If
            objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate,(Security,Backup)}!\\.\root\cimv2")
            colMonitoredEvents = objWMIService. _
            ExecNotificationQuery("select * from __InstanceCreationEvent  where TargetInstance isa  'Win32_NTLogEvent'")

            Dim i As Integer = 0
            Do While i = 0
                'TextFileLogging("Found event..")
                objLatestEvent = colMonitoredEvents.NextEvent
                evento = objLatestEvent.TargetInstance
                With evento
                    ID = CInt(.EventCode)
                    Source = .SourceName
                    If IsDBNull(.Message) Then
                        Message = "N/A"
                    Else
                        Message = .Message
                    End If
                    If ID = 529 Then
                        'RDP Failure Login
                        AttackDetected(ParseRDPMessage(Message), 1, Now)
                    ElseIf ID = 18456 Then
                        'MSSQL Failure Login
                        AttackDetected(ParseMSSQLMessage(Message), 2, Now)
                    ElseIf ID = 100 And UCase(Source) = "MSFTPSVC" Then
                        'FTP Failure Login
                        AttackDetected(ParseFTPMessage(), 3, Now)
                    End If
                End With
            Loop
        Catch ex As Exception
            TextFileLogging(ex.ToString)
        End Try
    End Sub

End Module
