Imports System.DirectoryServices
Imports MSUtil  'REMEMBER TO MAKE REGSVR32 LOGPARSER.DLL
Imports System.IO

Module FTP

    Public Function GetFTPLogFile()
        Const FtpServerSchema As String = "IIsFtpServer"
        Dim foldername As String
        Dim serverName As String
        serverName = System.Environment.MachineName

        Dim MSFTPSVC As New DirectoryEntry("IIS://" + serverName + "/msftpsvc")
        For Each Site As DirectoryEntry In MSFTPSVC.Children
            If Site.SchemaClassName = FtpServerSchema Then
                foldername = System.IO.Path.Combine(Site.Properties("LogFileDirectory").Value.ToString(), "MSFTPSVC" + Site.Name)
            End If
        Next
        Dim filename As String

        Dim di As New IO.DirectoryInfo(foldername)
        Dim aryFi As IO.FileInfo() = di.GetFiles("*.log")
        Dim fi As IO.FileInfo

        For Each fi In aryFi
            filename = fi.FullName
        Next

        Return filename
    End Function

    Public Function ParseFTPMessage() As String
        If VerboseLogging = True Then
            TextFileLogging("ParseFTPMessage")
        End If
        Return ParseW3CLog()
    End Function


    Public Function ParseW3CLog() As String
        ' prepare LogParser Recordset & Record objects 
        Dim rsLP As ILogRecordset = Nothing
        Dim rowLP As ILogRecord = Nothing
        Dim LogParser As LogQueryClassClass = Nothing
        Dim W3Clog As COMW3CInputContextClassClass = Nothing
        Dim strSQL As String = Nothing
        Try
            LogParser = New LogQueryClassClass()
            W3Clog = New COMW3CInputContextClassClass()
            If VerboseLogging = True Then
                TextFileLogging("ParseW3CLog")
            End If
            strSQL = "SELECT c-ip from " & GetFTPLogFile() & " WHERE sc-status = 331"
            ' run the query against W3C log 
            rsLP = LogParser.Execute(strSQL, W3Clog)
            'obtain last row
            While Not rsLP.atEnd
                rowLP = rsLP.getRecord()
                rsLP.moveNext()
            End While
            'return IP address
            Return rowLP.getValue(0)
        Catch
            Throw
        End Try
    End Function
End Module
