Module RDP

#Region "Example"
    'Event Type:	Failure Audit
    'Event Source:	Security
    'Event Category:	Logon/Logoff 
    'Event ID:	529
    'Date:		25/05/2008
    'Time:		23.16.05
    'User:		NT AUTHORITY\SYSTEM
    'Computer:	MAIL
    'Description:
    'Logon Failure:
    ' 	Reason:		Unknown user name or bad password
    ' 	User Name:	administrator
    ' 	Domain:		DOMAIN
    ' 	Logon Type:	10
    ' 	Logon Process:	User32  
    ' 	Authentication Package:	Negotiate
    ' 	Workstation Name:	MYPC
    ' 	Caller User Name:	MYPC$
    ' 	Caller Domain:	DOMAIN
    ' 	Caller Logon ID:	(0x0,0x3E7)
    ' 	Caller Process ID:	3836
    ' 	Transited Services:	-
    ' 	Source Network Address:	127.0.0.1
    ' 	Source Port:	2174
#End Region


    Public Function ParseRDPMessage(ByVal message As String) As String
        'EG. Source Network Address:	192.168.1.1
        Try
            If VerboseLogging = True Then
                TextFileLogging("ParseRDPMessage")
            End If
            Dim IP As String = ""
            Dim pos As Integer
            pos = InStr(message, "Source Network Address:")
            If pos = 0 Then
                Return "ERROR"
            End If
            message = message.Substring(pos - 1 + Len("Source Network Address:"))
            message = Trim(message)
            If Asc(message.Substring(0, 1)) = 9 Then
                'There is a TAB
                message = message.Substring(1)
            End If
            Return ParseIPFromString(message)
        Catch ex As Exception
            Return "ERROR"
        End Try
    End Function

    Private Function ParseIPFromString(ByVal message As String) As String
        Dim IP As String = ""
        Dim pos As Integer
        pos = InStr(Message, ".")
        IP = LTrim(Message.Substring(0, pos))
        Message = Message.Substring(pos)

        pos = InStr(Message, ".")
        IP &= Message.Substring(0, pos)
        Message = Message.Substring(pos)

        pos = InStr(Message, ".")
        IP &= Message.Substring(0, pos)
        Message = Message.Substring(pos)

        If IsNumeric(Message.Substring(0, 1)) Then
            IP &= Message.Substring(0, 1)
            If IsNumeric(Message.Substring(1, 1)) Then
                IP &= Message.Substring(1, 1)
                If IsNumeric(Message.Substring(2, 1)) Then
                    IP &= Message.Substring(2, 1)
                End If
            End If
        End If

        Return LTrim(IP)
    End Function

End Module
