Imports System.ServiceProcess
Imports System.Reflection.Assembly

Public Class WinService
    Inherits System.ServiceProcess.ServiceBase

#Region " Codice generato da Progettazione componenti "

    Public Sub New()
        MyBase.New()

        ' Chiamata richiesta da Progettazione componenti.
        InitializeComponent()

        ' Aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitializeComponent()

    End Sub

    'UserService esegue l'override del metodo Dispose per pulire l'elenco dei componenti.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Punto di ingresso principale del processo
    <MTAThread()> _
    Shared Sub Main()
        Dim ServicesToRun() As System.ServiceProcess.ServiceBase

        ' All'interno di uno stesso processo  possibile eseguire pi servizi di Windows NT.
        ' Per aggiungere un servizio al processo, modificare la riga che segue in modo
        ' da creare un secondo oggetto servizio. Ad esempio,
        '
        '   ServicesToRun = New System.ServiceProcess.ServiceBase () {New Service1, New MySecondUserService}
        '
        ServicesToRun = New System.ServiceProcess.ServiceBase() {New WinService}

        System.ServiceProcess.ServiceBase.Run(ServicesToRun)
    End Sub

    'Richiesto da Progettazione componenti
    Private components As System.ComponentModel.IContainer

    ' NOTA: la procedura che segue  richiesta da Progettazione componenti
    ' Pu essere modificata in Progettazione componenti.  
    ' Non modificarla nell'editor del codice.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'HealthMonitor
        '
        Me.ServiceName = "WinFail2Ban"

    End Sub

#End Region

    Dim version, name As String
    Dim Thread1 As System.Threading.Thread

    Protected Overrides Sub OnStart(ByVal args() As String)
        Try
            'Get version information
            version = System.Reflection.Assembly.GetExecutingAssembly.GetName.Version.Major & "." & System.Reflection.Assembly.GetExecutingAssembly.GetName.Version.Minor
            name = System.Reflection.Assembly.GetExecutingAssembly.GetName.Name
            Dim Arguments As [String]() = Environment.GetCommandLineArgs()
            ReadParameters()
            ' Log Starting
            If VerboseLogging = True Then
                TextFileLogging("Starting " & name & " " & version & " (enable verbose logging)")
            Else
                TextFileLogging("Starting " & name & " " & version)
            End If
            If Not EventLog.SourceExists(name) Then
                EventLog.CreateEventSource(name, "Application")
            End If

            Thread1 = New System.Threading.Thread(AddressOf WaitForEvent)
            Thread1.Start()
        Catch ex As Exception
            TextFileLogging(ex.ToString)
        End Try
    End Sub

    Protected Overrides Sub OnStop()
        TextFileLogging("Stopping " & name & " " & version)
        Thread1.Suspend()
    End Sub


End Class
